  void Tube(PVector direction){ //create tube
    pushMatrix();
    PVector polar = cartesianToPolar(direction); 
    rotateY(polar.y); 
    rotateZ(polar.z);
    drawCylinder();
    popMatrix();
  }

 void drawCylinder(){
    float cylinderLength = porusheight;
   int pts = 5; 
   PVector [][] vertices = new PVector[2][pts+1];
        noStroke();
    // fill arrays
    for (int i = 0; i < 2; i++){
      float angle = 0; float rradius = poruswidth; 
     
      for(int j = 0; j <= pts; j++){
        vertices[i][j] = new PVector();
        vertices[i][j].x = cos(radians(angle)) * rradius;
        vertices[i][j].y = sin(radians(angle)) * rradius;
        vertices[i][j].z = cylinderLength*2; 
        // the .0 after the 360 is critical
        angle += 360.0/pts;
      }  
      cylinderLength *= -1;
    }

    // draw cylinder tube
    beginShape(QUAD_STRIP);
    pushMatrix();
    rotateY(PI/2);
    translate(0, 0, -cylinderLength);
    for(int j = 0; j <= pts; j++){
      vertex(vertices[0][j].x, vertices[0][j].y, vertices[0][j].z);
      vertex(vertices[1][j].x, vertices[1][j].y, vertices[1][j].z);
    }
    endShape();

    //draw cylinder ends
    pushMatrix();
    for (int i = 0; i < 2; i++){
      beginShape();
      for(int j = 0; j < pts; j++){
        vertex(vertices[i][j].x, vertices[i][j].y, vertices[i][j].z);
      }
      endShape(CLOSE);
    }
    popMatrix();
    popMatrix();

  }

  PVector cartesianToPolar(PVector theVector) { 
    PVector res = new PVector(); 
    res.x = theVector.mag(); 
    if (res.x > 0) { 
      res.y = -atan2(theVector.z, theVector.x); 
      res.z = asin(theVector.y / res.x); 
    }  
    else { 
      res.y = 0; 
      res.z = 0; 
    } 
    return res; 
  }
