void load_VXC() {
  getFile =getFileName();
  format = "vxc";
}

public void load_VOXEL_txt() {
  getFile = getFileName();
  format = "txt";
}

void loadVoxelarray() {

  String regex = "(\\D+)([0-9]+)";
  String target;
  Matcher matcher;
  Pattern pattern;

  //  int resolution = 0;
  int[][][] tmpxyzarrays = new int[48][48][48];
  int currentX = 0;
  int currentY = 0;

  if (getFile == null) {
    // If a file was not selected
    println("No input file was selected...");
  }
  else {
    try {
      BufferedReader br = new BufferedReader(new FileReader(getFile)); 
      //ファイルの件数分ループして配列に格納します。 
      while ( (target = br.readLine ())!= null) {      
        pattern = Pattern.compile(",");
        String[] strs = pattern.split(target);

        if (strs[0].equals("resolution")) {
          resolution = Integer.parseInt(strs[1]);
        }
        else {
          for (int i=0;i<resolution;i++) {
            tmpxyzarrays[currentX][currentY][i] = Integer.parseInt(strs[i]);
          }
          currentY = currentY + 1;
          if (currentY == resolution) {
            currentY = 0;
            currentX = currentX + 1;
          }
        }
      }
      br.close();
    } 
    catch (Exception ex) {
      ex.printStackTrace();
    }
    xyzarrays = tmpxyzarrays;
    println("Loading voxel data was completed.");
    println("Resolution : " + resolution);
    format="";
    getFile="";
  }
}

void loadXMLVXC() {
  xml =  new XMLElement(this, getFile); 

  XMLElement kid = xml.getChild("Structure");
  resolution = int(kid.getChild("X_Voxels").getContent());

  println(resolution);
  int[][][] tmpxyzarrays = new int[resolution][resolution][resolution];


  for (int i=0; i<resolution; i++) {
    String binarydata =  kid.getChild("Data").getChild(i).getContent();

    int upp=resolution*resolution-1;
    //int upp=0;

    for (int kk=0; kk<resolution; kk++) {
      for (int jj=0; jj<resolution; jj++) {

        if (binarydata.charAt(upp)=='0') {      
          tmpxyzarrays[kk][jj][i]= 0;
        }
        if (binarydata.charAt(upp)=='1') {      
          tmpxyzarrays[kk][jj][i]= 1;
        }
        upp--;
      }
    }
  } 

  xyzarrays= tmpxyzarrays;
  format =""; 
  getFile="";
}


public void load_STL() {
  getFile = getFileName();
  format ="stl";
}


public void save_STL() {
  setFile = setFileName();
  format = "stl";
}

void save_VOXELtxt() {
  setFile = setFileName();
  format = "txt";
}

void save_VXC() {
  //print("savevxchere");
  setFile = setFileName();
  format = "vxc";
}

void  writeVXC() {
  String savePath = setFile;

  if (savePath == null) {
    // If a file was not selected
    println("No output file was selected...");
  }
  else {
    try {
      File file = new File(savePath + "."+ format);
      PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(file)));

      pw.print("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?> \n\n");
      pw.print("<VXC Version=\"0.94\"> \n\n");
      pw.print("<Lattice> \n\n");
      pw.print("<Lattice_Dim>0.001</Lattice_Dim> \n\n");
     if (whole_uniform_dithering == false && inner_uniform_dithering == false) {
      pw.print("<X_Dim_Adj>" + FIELD_STEP + "</X_Dim_Adj> \n\n");
      pw.print("<Y_Dim_Adj>" + FIELD_STEP + "</Y_Dim_Adj> \n\n");
      pw.print("<Z_Dim_Adj>" + FIELD_STEP + "</Z_Dim_Adj> \n\n");
     }
     if (whole_uniform_dithering == true || inner_uniform_dithering == true) {
      pw.print("<X_Dim_Adj>" + FIELD_STEP/2 + "</X_Dim_Adj> \n\n");
      pw.print("<Y_Dim_Adj>" + FIELD_STEP/2 + "</Y_Dim_Adj> \n\n");
      pw.print("<Z_Dim_Adj>" + FIELD_STEP/2 + "</Z_Dim_Adj> \n\n");
       
     }
      //pw.print("<X_Dim_Adj>1</X_Dim_Adj> \n\n");
      //pw.print("<Y_Dim_Adj>1</Y_Dim_Adj> \n\n");
      //pw.print("<Z_Dim_Adj>1</Z_Dim_Adj> \n\n");
      pw.print("<X_Line_Offset>0</X_Line_Offset> \n\n");
      pw.print("<Y_Line_Offset>0</Y_Line_Offset> \n\n");
      pw.print("<X_Layer_Offset>0</X_Layer_Offset> \n\n");
      pw.print("<Y_Layer_Offset>0</Y_Layer_Offset> \n\n");
      pw.print("</Lattice> \n\n");

      pw.print("<Voxel> \n\n");
      pw.print("<Vox_Name>BOX</Vox_Name> \n\n");
      //pw.print("<X_Squeeze>1</X_Squeeze> \n\n");
      //pw.print("<Y_Squeeze>1</Y_Squeeze> \n\n");
      //pw.print("<Z_Squeeze>1</Z_Squeeze> \n\n");
     if (whole_uniform_dithering == false && inner_uniform_dithering == false) {
      pw.print("<X_Squeeze>" + FIELD_STEP + "</X_Squeeze> \n\n");
      pw.print("<Y_Squeeze>" + FIELD_STEP + "</Y_Squeeze> \n\n");
      pw.print("<Z_Squeeze>" + FIELD_STEP + "</Z_Squeeze> \n\n");
     }
     if (whole_uniform_dithering == true || inner_uniform_dithering == true) {
      pw.print("<X_Squeeze>" + FIELD_STEP/2 + "</X_Squeeze> \n\n");
      pw.print("<Y_Squeeze>" + FIELD_STEP/2 + "</Y_Squeeze> \n\n");
      pw.print("<Z_Squeeze>" + FIELD_STEP/2 + "</Z_Squeeze> \n\n");
       
     }

      pw.print("</Voxel>\n\n");
      pw.print(" <Palette>\n\n");
      pw.print("<Material ID=\"1\">\n\n");
      pw.print("<MatType>0</MatType>\n\n");
      pw.print("<Name>Default</Name>\n\n");
      pw.print("<Display>\n\n");
      pw.print("  <Red>0.498039</Red>\n\n");
      pw.print("  <Green>1</Green>\n\n");
      pw.print("  <Blue>0</Blue>\n\n");
      pw.print("  <Alpha>1</Alpha>\n\n");
      pw.print("</Display>\n\n");
      pw.print("<Mechanical>\n\n");
      pw.print("  <MatModel>0</MatModel>\n\n");
      pw.print("  <Elastic_Mod>1e+006</Elastic_Mod>\n\n");
      pw.print("  <Plastic_Mod>0</Plastic_Mod>\n\n");
      pw.print("  <Yield_Stress>0</Yield_Stress>\n\n");
      pw.print("  <FailModel>0</FailModel>\n\n");
      pw.print("  <Fail_Stress>0</Fail_Stress>\n\n");
      pw.print("  <Fail_Strain>0</Fail_Strain>\n\n");
      pw.print("  <Density>1</Density>\n\n");
      pw.print("  <Poissons_Ratio>0.35</Poissons_Ratio>\n\n");
      pw.print("  <CTE>0</CTE>\n\n");
      pw.print("  <MaterialTempPhase>0</MaterialTempPhase>\n\n");
      pw.print("  <uStatic>1</uStatic>\n\n");
      pw.print("  <uDynamic>0.5</uDynamic>\n\n");
      pw.print("</Mechanical>\n\n");
      pw.print("</Material>\n\n");
      pw.print(" </Palette>\n\n");
      pw.print(" <Structure Compression=\"ASCII_READABLE\">\n\n");

      if (whole_uniform_dithering == false && inner_uniform_dithering == false) {
        pw.print("  <X_Voxels>" + resolution + "</X_Voxels> \n\n");
        pw.print("  <Y_Voxels>" + resolution + "</Y_Voxels> \n\n");
        pw.print("  <Z_Voxels>" + resolution + "</Z_Voxels> \n\n");
        pw.print(" <Data> \n");
      }

      if (whole_uniform_dithering == true || inner_uniform_dithering == true) {
        pw.print("  <X_Voxels>" + resolution*2 + "</X_Voxels> \n\n");
        pw.print("  <Y_Voxels>" + resolution*2 + "</Y_Voxels> \n\n");
        pw.print("  <Z_Voxels>" + resolution*2 + "</Z_Voxels> \n\n");
        pw.print(" <Data> \n");
      }

      if (whole_uniform_dithering == false && inner_uniform_dithering == false) {
        for (int i=0; i<resolution; i++) {
          pw.print(" <Layer><![CDATA[");
          for (int j=0; j<resolution; j++) {
            for (int k=0; k<resolution; k++) {
              if (xyzarrays[k][j][i]==0) { 
                pw.print(0);
              }
              else { 
                pw.print(1);
              }
            }
          }
          pw.print("]]></Layer> \n\n");
        }
      }
      else if (whole_uniform_dithering == true || inner_uniform_dithering == true) {
        for (int i=0; i<resolution*2; i++) {
          pw.print(" <Layer><![CDATA[");
          for (int j=0; j<resolution*2; j++) {
            for (int k=0; k<resolution*2; k++) {
              if (xyzarrays[k][j][i]==0) { 
                pw.print(0);
              }
              else { 
                pw.print(1);
              }
            }
          }
          pw.print("]]></Layer> \n\n");
        }
      }

      pw.print("\n\n");

      pw.print("</Data> \n\n");
      pw.print("</Structure> \n\n");
      pw.print("</VXC> \n\n");


      pw.close();
    }
    catch(IOException e) {
      System.out.println(e);
    }
  }
  setFile = "";
  format = "";  
  println("saveVXC end");
}

void writeVoxel() {
  String savePath = setFile;

  if (savePath == null) {
    // If a file was not selected
    println("No output file was selected...");
  }
  else {
    try {
      File file = new File(savePath + "."+ format);
      PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(file)));
      pw.println("resolution," + resolution);

      for (int i=0; i<resolution; i++) {
        for (int j=0; j<resolution; j++) {
          for (int k=0; k<resolution; k++) {
            pw.print(xyzarrays[i][j][k]);
            if (k<resolution-1) pw.print(",");
          }
          pw.print("\n");
        }
      }
      pw.close();
    }
    catch(IOException e) {
      System.out.println(e);
    }
  }
  setFile = "";
  format = "";  
  println("savevoxel end");
}

//ファイルを取り込むファンクション 
void fileLoader() {
  //選択ファイルパスのドット以降の文字列を取得
  String ext = getFile.substring(getFile.lastIndexOf('.') + 1);
  //その文字列を小文字にする
  ext.toLowerCase();
  //文字列末尾がstlであれば 
  if (ext.equals("stl")) {
    println(ext);
    stl=new STL(this, getFile);
    // Get polygon data

    poly=stl.getPolyData();
    faces = poly.num;

    FIELD_STEP = FIELD_SIZE*2/resolution;
    //poly.normalize(FIELD_SIZE*2-FIELD_STEP*2); // normalize object to 400 radius
    poly.normalize(FIELD_STEP * resolution * 0.99); // normalize object to 400 radius
    poly.calcBounds();
    poly.center(); // center it around world origin

    mesh = (WETriangleMesh) new STLReader().loadBinary(sketchPath(getFile), STLReader.WEMESH);

    initPhysics();
  }

  //選択ファイルパスを空に戻す
  getFile = "";
}



//ファイル選択画面、選択ファイルパス取得の処理 
String getFileName() {
  //処理タイミングの設定 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
      try {
        //ファイル選択画面表示 
        JFileChooser fc = new JFileChooser(); 
        int returnVal = fc.showOpenDialog(null);
        //「開く」ボタンが押された場合
        if (returnVal == JFileChooser.APPROVE_OPTION) {
          //選択ファイル取得 
          File file = fc.getSelectedFile();
          //選択ファイルのパス取得 
          getFile = file.getPath();
        }
      }
      //上記以外の場合 
      catch (Exception e) {
        //エラー出力 
        e.printStackTrace();
      }
    }
  } 
  );
  //選択ファイルパス取得
  return getFile;
}


//ファイル選択画面、選択ファイルパス取得の処理 
String setFileName() {
  //処理タイミングの設定 
  SwingUtilities.invokeLater(new Runnable() { 
    public void run() {
      try {
        //ファイル選択画面表示 
        JFileChooser fc = new JFileChooser(); 
        int returnVal = fc.showSaveDialog(null);
        //「開く」ボタンが押された場合
        if (returnVal == JFileChooser.APPROVE_OPTION) {
          //選択ファイル取得 
          File file = fc.getSelectedFile();
          //選択ファイルのパス取得 
          setFile = file.getPath();
        }
      }
      //上記以外の場合 
      catch (Exception e) {
        //エラー出力 
        e.printStackTrace();
      }
    }
  } 
  );
  //選択ファイルパス取得
  return setFile;
}

