// G-code descriptions
//  	E  押出される長さ(単位mm)。押し出されるフィラメントの長さ。Skeinforge 40もしくは40以上は、押出される長さではなく、消費される入力フィラメントの長さとして、この長さを扱う。
//      F   	フィード率(プリンタのヘッドが動くスピード)。１分に何mmフィードするか指定する。
//      フィード率を1500mm/分
//      G28: 原点に移動する(Move to Origin) 
//       G20: 単位をインチに指定する
//      G21: 単位をミリに指定する
//     G90: 絶対的な位置を設定(Set to Absolute Positioning)
// 全ての座標は、マシンの原点からの絶対的な位置となる。(これはRepRapのデフォルトである)
// G91: 相対的な位置を設定する(Set to Relative Positioning)
//  全ての座標は、最後の位置の相対的な位置となる。 
//  G92: 位置を指定する(Set Position)
//
// 現在の座標を指定した値にリセットする。これは、原点に対して絶対座標を指定するプログラムを可能にする。 上記の例は、マシンのX座標を10、押出座標を90に設定する。物理的な移動は起きない。


// 出だしのコード
// G28
//M140 S60
//M190 S60
//M104 S220
//M109 S220
//M42 P6 S255<FAN>

//G92 E0
//T0
//M104 S220


//終わりのコード
//M104 S0
//M190 S0
//M107
//M42 P6 S0<FAN>
//G28


// Voxel to G-Code 
int gcode_xyzpitch = 1; // 単位mm 
int gcode_extrude = 1; // 単位mm 
int gcode_feedrate = 1000; // mm/分

String[] gcode = new String[100000];
 
void gcodedots(){
              
  int gcodeline = 0; 
  
  gcode[gcodeline]= "G28"; gcodeline++; 
  gcode[gcodeline]= "M140 S60"; gcodeline++;   
  gcode[gcodeline]= "M190 S60"; gcodeline++; 
  gcode[gcodeline]= "M104 S220"; gcodeline++; 
  gcode[gcodeline]= "M109 S220"; gcodeline++; 
  gcode[gcodeline]= "M42 P6 S255<FAN>"; gcodeline++; 
  gcode[gcodeline]= "G92 E0"; gcodeline++; 
  gcode[gcodeline]= "T0"; gcodeline++; 
  gcode[gcodeline]= "M104 S220"; gcodeline++; 


  
  FIELD_STEP = gcode_xyzpitch;
  
  int blankcount = 0;

  for(int k = int((resolution-1)*z_scan/100)+1; k<=resolution; k = k + 1){
    for(int j = 1; j<=resolution; j = j + 1){
       for(int i = 1; i<=resolution; i = i + 1){
       
          //x
          float x = -FIELD_STEP*resolution/2 + FIELD_STEP*(i - 1);
          float xx = -FIELD_STEP*resolution/2 + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          //y
          float y = -FIELD_STEP*resolution/2+ FIELD_STEP*(j - 1);
          float yy = -FIELD_STEP*resolution/2 + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          //z
          float z =  FIELD_STEP*(k - 1);
          float zz = FIELD_STEP*(k);
          float realz = z; 
          
          gcode[gcodeline]= "G1 X"+realx+ " Y"+realy+ " Z"+realz + " F"+gcode_feedrate;  gcodeline++; 
          
              if(  xyzarrays[i-1][j-1][k-1] == 1 ){
          gcode[gcodeline]= "G1 E"+gcode_extrude; gcodeline++; 
              }
              
        
       }
    }
  }

  gcode[gcodeline]= "M104 S0"; gcodeline++; 
  gcode[gcodeline]= "M190 S0"; gcodeline++;   
  gcode[gcodeline]= "M107"; gcodeline++; 
  gcode[gcodeline]= "M42 P6 S0<FAN>"; gcodeline++; 
  gcode[gcodeline]= "G28"; 
  
  
  saveStrings(year() + "_" + month() + "_" + day() + "_" + hour() + "_" + minute() + "_" + second() +  "_dot" + ".gcode", gcode);
       
     }
     
     
     

       
